; vlc.jss
; (c) 2019 by Udo Egner-Walter

Include "HjGlobal.jsh"
Include "hjconst.jsh"
Include "common.jsm"
include "UIA.jsh"
include "vlc.jsh"

; -----------------------------------------------------------------------------------------------
; bersicht Funktionen
; -----------------------------------------------------------------------------------------------
; void function FocusChangedEventEx (...): JAWS-Event bei Fokuswechsel
; void Function TutorMessageEvent (...): JAWS-Event fr Hilfemeldungen
; void Function ObjStateChangedEvent (...): JAWS-Event fr genderten Zustand (Kontrollkstchen)
; string Function GetStaticText (int iPos): Zeit, Titel etc. ermitteln 
; ------- berprfen des Fokus bzw. aktives Steuerelemnt ---------------------
; int Function IsPlayerWindow (): Ist der Fokus im Hauptfenster? 
; int Function IsDialogEffects (): Ist der Fokus im Dialog "Anpassungen und Effekte" 
; int Function IsDialogGoTo (); Ist der Fokus im Dialog "Zu Zeitpunkt gehen"
; int Function IsDialogMediaInformation (): Ist der Fokus im Dialopg "Aktuelle Medieninformationen"
; int Function isRepeatCheckBox  (object oEntry): Ist das Objekt die Checkbox "Wiederholen"
; int Function isRandomCheckBox  (object oEntry): Ist das Objekt die Checkbox "Zufllig"
; int Function isPlaylistCheckBox  (object oEntry): Ist das Objekt die Checkbox "Playlist"
; int Function isRecordingCheckBox  (object oEntry): Ist das Objekct die Checkbox "Aufnehmen"
; int Function IsStatusBarActive (): Ist die Statusleiste eingeblendet 
; int IsPlaylistActive (): Wird die Playlilst im VLC-Fenster angezeigt?
; int Function IsMuting (): Prft, ob auf Stumm geschaltet wurde (Taste M)
; int Function IsFileOpen (): Prft, ob eine Datei geffnet ist 
; int Function IsFileOpenEx (): Prft, ob eine Datei geffnet ist (hier zustzlich ber Statusleiste, was in Skripts, die "GetStaticText" benutzen, nicht immer zuverlssig funktioniert)
; int Function IsCheckBoxChecked (object oCheckbox): Prft, ob die bergebene Checkbox ausgewhlt ist oder nicht 
; ------- Finden ber MSAA-Description ---------------------------------------------------
; int Function GetFocussableUIAObjectNumberWithMSAADescription (string sDescription, optional int iPartOfString): Sucht in den MSAA-Descriptions nach "sDescription" und gibt die Nummer zurck
; object Function GetFocussableUIAObjectWithMSAADescription (string sDescription, optional int iPartOfString): Sucht in den MSAA-Descriptions nach "sDescription" und gibt das UIA-Element-Objekt zurck
; int Function InvokeFocussableUIAObjectWithMSAADescription (string sDescription, optional int iPartOfString): Sucht in den MSAA-Descriptions nach "sDescription" und fhrt dann die Standard-UIA-Aktion aus 
; int Function ClickFocussableUIAObjectWithMSAADescription (string sDescription, optional int iPartOfString): Sucht in den MSAA-Descriptions nach "sDescription" und fhrt dann einen Mausklick aus 
; int Function SetFocusToFocussableUIAObjectWithMSAADescription (string sDescription, optional int iPartOfString): Sucht in den MSAA-Description nach "sDescription" und setzt dann den Fokus darauf 
; int Function PerformActionFocussableOnUIAElementWithMSAADescription (int iAction, string sDescription, optional int iPartOfString)
; ------- Finden ber die Nummer ---------------------------------------------------
; object Function GetFocussableUIAObjectWithNumber (int iNumber): gibt UIA-Objekt anhand der Nummer zurck 
; int Function InvokeFocussableUIAObjectWithNumber (int iNumber): fhrt den Invoke-Befehlt fr das UIA-Objekt mit der angegebenen Nummer aus 
; int Function ClickFocussableUIAObjectWithNumber (int iNumber): fhrt einen Mausklick auf das UIA-Objekt mit der angegebenen Nummer aus 
; int Function SetFocusToFocussableUIAObjectWithNumber (int iNumber): Setzt den Fokus auf das UIA-Objekt mit der angegebenen Nummer aus 
; int Function PerformActionOnFocussableUIAElementWithNumber (int iAction, int iNumber): fhrt die in "iAction" angegebene Aktion auf das UIA-Objekt mit der angegebenen Nummer aus 
; int Function GetFocussableUIAObjectsCount (): Gibt die Anzahl der Steuerelemente zurck, die (im Player) fokussiert werden knnen
; string Function GetDescriptionFromNumber (int iNumber, optional int iStatus): Anhand der Nummer den MSAA-Beschreibungstext erhalten
; ------- Tab-Control ---------------------------------------------------
; string Function GetTabNames (): gibt alles Tabs als Liste zurck
; int Function SelectTabByNumber (int iNumber): klickt auf einem bestimmten Tab
; string Function GetCheckBoxTabNames ()
; int Function SelectCheckBoxTabByNumber (int iNumber)
; ------- Sonstiges ---------------------------------------------------
; void Function SayTabPosition (optional int iStatus): kndigt nach Drcken von Tab, Shift+Tab und Enter die Schaltflche an 
; string Function GetRecentFileList (): Liste der zuletzt geffneten Dateien ermitteln 
; void Function SendToBraille (string sMessage): zeigt Text auf der Braille-Zeile an
; void Function ProcessKeyPressed (...): auf VLC-Tasten reagieren
; void Function AutoStartEvent (): Player-Fenster aktivieren 
;
; -----------------------------------------------------------------------------------------------
; bersicht Skripts
; -----------------------------------------------------------------------------------------------
;
; ------- Ansage statischer Text ---- ---------------------------------------------------
; Script SayPosition (Control+Space&p): aktuelle Position (abgelaufene Zeit, links des Schiebereglers)
; Script SayLengthOrRemainingTime (Control+Space&F5): Gesamtabspielzeit/noch verbleibende Zeit, rechts des Schiebereglers
; Script SayFilename (Control+Space&d): Ansage der aktuellen Datei (wenn Statusleiste eingeblendet ist)
; Script SaySpeed (Control+Space&g): Ansage der Wiedergabegeschwindigkeit (wenn Statusleiste eingeblendet ist)
; Script SayPositionOrRemainingTimeAndLength (Control+Space&F6): Ansage von Position und Gesamtlnge (wenn Statusleiste eingeblendet ist)
; ------- Einstellungen im Player-Fenster ndern ----------------------------------
; Script ChangeTimeDisplay (Control+Space&F1): Anzeigeeinstellung in der Positionsanzeige umschalten zwischen verbleibender Zeit und Gesamtlnge
; Script ChangeTimeDisplayStatusBar (Control+Space&F2): Anzeigeeinstellung in der Statuszeile umschalten zwischen aktueller Position und verbleibender Zeit 
; Script ChangeSpeedSlower (Control+F3): Wiedergabegeschwindigkeit ndern (langsamer)
; Script ChangeSpeedFaster (Control+F4): Wiedergabegeschwindigkeit ndern (schneller)
; Script ChangePlayerPlaylistView (Control+P): Schaltet zwischen Player-Ansicht und Playlist-Ansicht um
; ------- In Listen anzeigen --------------------------------------------------------------
; Script ShowOpenDialogsInList (Control+Space&F): zeigt einen Auswahldialog mit geffneten Fenster an 
; Script ShowRecentFileList (Control+Space&W): zeigt einen Auswahldialog mit den zuletzt geffneten Dateien an 
; Script ShowTabItems (Control+Space&T): zeigt einen Auswahldialog mit Registerkarteneintrgen an 
; ------- VLC Tasten ------------------------------------------------------------------------
; Script VLCControlUpArrow (Control+UpArrow): Ansage der Taste
; Script VLCControlDownArrow (Control+DownArrow): Ansage der Taste
; Script ShowContextMenu (Anwendungsmen, Shift+F10): Setzt Fokus auf Steuerelemente,, sodass das Anwendungsmen ausgefhrt werden kann
; Script ChangePosition (Shift+LeftArrow, Shift+RightArrow, Alt+LeftArrow, Alt+RightArrow, Control+LeftArrow, Control+RightArrow): Taste an VLC weiterreichen und Position sprechen
; Script VLCTab (Tab): Setzt im Player-Fenster den Fokus auf die nchste Schaltflche 
; Script VLCShiftTab (Umschalt+Tab): Setzt im Player-Fenster den Fokus auf die vorherige Schaltflche 
; Script VLCEnter (Enter): Fhrt im Player-Fenster Schaltflchen aus 
; ------- VLC-Dialoge --------------------------------------------------------------
; Script ShowDialogEffects (Control+E): Zeigt den Dialog "Anpassungen und Effekte" an oder aktiviert ihn
; Script ShowDialogMediaInfos (Control+I): Zeigt den Dialog "Medianinformationen" an oder aktiviert ihn
; Script ShowDialogMediaCodec (Control+J): Zeigt die Registerkarte "Codec" im Dialog "Medianinformationen" an oder aktiviert sie
; Script ShowDialogVLMConfiguration (Control+Shift+W): Zeigt den VLM-Konfigurations-Dialog an oder aktiviert ihn
; Script ShowDialogMessages (Control+M): Zeigt den Dialog "Meldungen" an oder aktiviert ihn
; Script ShowDialogBookmarks (Control+B): Zeigt den Dialog "Lesezeichen bearbeiten" an oder aktiviert ihn 
; Script ShowDialogGoTo (Control+T): Zeigt den Dialog "Zu Zeitpunkt gehen" an oder aktiviert ihn 
; ------- Sonstiges-------------------------------------------------------------- 
; Script ShowPlayerWindow (Control+Space&V): Holt das VLC-Player-Fenster in den Vordergrund
; Script SayHelp (Control+Space&H): zeigt alle Skript-Kurztasten im virtuellen Betrachter an
; ------- Standard-JAWS-Skripts -------------------------------------------------------------- 
; Script ScriptFileName (JAWs+Q): Spricht Skript-Datei

; xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
; Funktionen
; xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

; -----------------------------------------------------------------------------------------------
; Event wird ausgelst, sobald der Fokus wechselt (JAWS-Event)
; -----------------------------------------------------------------------------------------------

void function FocusChangedEventEx (
	handle hwndFocus, int nObject, int nChild,
	handle hwndPrevFocus, int nPrevObject, int nPrevChild,
	int nChangeDepth)

var
object oTree,
object oActElement, 
string sTemp,
object oCurObject

; im Dialog "Aktuelle Medieninformationen) werden nicht 
; alle Eingabefelder korrekt gesprochen, deshalb hier 
; eine Nachbesserung:
If IsDialogMediaInformation () then
   oTree = GetUIAObjectTree(GetAppMainWindow(GetFocus()))
   if !oTree then return EndIf
   oActElement = oTree.FindByKeyboardFocus (True)
   if !oActElement then return EndIf 

   ; nur wenn der Name nicht vorhanden ist 
   ; den Namen (Beschreibung) des vorhergehenden Elements sprechen 
  If oActElement.Name == "" then
    sTemp = oActElement.PriorSibling.Name
    if sTemp == "/" then
      sTemp = msgTitleNumbers
    EndIf 
    if sTemp == cEditComments then
      giInCommentsEdit = True
    else
      giInCommentsEdit = False
    EndIf 
    SayFormattedMessage (OT_SCREEN_MESSAGE, sTemp)
    SendToBraille (sTemp)
  EndIf 
EndIf ; If GetWindowName (GetRealWindow(GetFocus())) == "Aktuelle Medieninformationen" then

oCurObject = GetUIAObjectFocusItem ()
If oCurObject.Name == "Nativen Style benutzen" || oCurObject.Name == "Benutzerdefinierte Oberflche verwenden" then
  If GetNonJCFOption("UseTutorMessagesForVLC") then
    SayFormattedMessage (OT_SCREEN_MESSAGE,  MsgSkinWarning)
    SendToBraille (MsgSkinWarning)
  EndIf ; If UseTutorMessagesForVLC then
EndIf ;  If oCurObject.Name == "Nativen Style benutzen" || oCurObject.Name == "Benutzerdefinierte Oberflche verwenden" then

var
string sDialogTitle = GetWindowName (GetRealWindow(GetFocus())),
string sName = oCurObject.Name
if sDialogTitle == cDialogNameSimplePreferences then
  If StringContains (cListOfTabs, "|" + sName + "|") then
    SayFormattedMessage (OT_SCREEN_MESSAGE, sName + cTabControlItem)
    SendToBraille (sName + cTabControlItem + cTabControlItemHelp)
    Return
  EndIf ; If StringContains (cListOfTabs, "|" + sName + "|") then
EndIf ; if sDialogTitle == cDialogNameSimplePreferences then

; Event weiterreichen 
FocusChangedEventEx (hwndFocus, nObject, nChild, hwndPrevFocus, nPrevObject, nPrevChild, nChangeDepth)
EndFunction

; -----------------------------------------------------------------------------------------------
; Event wird ausgelst, sobald der Fokus wechselt und 
; Hilfemeldungen gesprochen werden
; -----------------------------------------------------------------------------------------------

void Function TutorMessageEvent (handle hWindow, int iMenuMode)
var
string sDialogTitle = GetWindowName (GetRealWindow(GetFocus())),
object oCurObject = GetUIAObjectFocusItem (),
string sName = oCurObject.Name

; Bei Registerkarten richtige Tastaturbedienung sprechen
If GetObjectSubtypeCode() == 	WT_TABCONTROL then
  SayFormattedMessage (OT_SCREEN_MESSAGE, cTabControlItemHelp)
  Return
EndIf ; If GetObjectSubtypeCode() == 	WT_TABCONTROL then

if sDialogTitle == cDialogNameSimplePreferences then
  If StringContains (cListOfTabs, "|" + sName + "|") then
    SayFormattedMessage (OT_SCREEN_MESSAGE, cTabControlItemHelp)
    Return
  EndIf ; If StringContains (cListOfTabs, "|" + sName + "|") then
EndIf ; if sDialogTitle == cDialogNameSimplePreferences then
TutorMessageEvent (hWindow, iMenuMode)
EndFunction 

; -----------------------------------------------------------------------------------------------
; Event wird ausgelst, sobald sich der Zustand eines 
; Steuerelements ndert (z. B. bei Kontrollkstchen)
; -----------------------------------------------------------------------------------------------

void Function ObjStateChangedEvent (handle hWindow, int iObjType, int iChangeState, int iCurrentState)
var
string sDialogTitle = GetWindowName (GetRealWindow(GetFocus())),
object oCurObject = GetUIAObjectFocusItem (),
string sName = oCurObject.Name
if sDialogTitle == cDialogNameSimplePreferences then
      ; Wenn wir eine Checkbox-Registerkarte erkannt haben
      If StringContains (cListOfTabs, "|" + sName + "|") then
      ; Status nicht sprechen und Funktion verlassen
      Return
      EndIf ; If StringContains (cListOfTabs, "|" + sName + "|") then
EndIf ; if sDialogTitle == cDialogNameSimplePreferences then
; Event an andere Skriptdateien weiterreichen
ObjStateChangedEvent (hWindow, iObjType, iChangeState, iCurrentState)
EndFunction


; -----------------------------------------------------------------------------------------------
; Statischen Text ermitteln (Zeit, Titel etc.)
; -----------------------------------------------------------------------------------------------

String Function GetStaticText (int iPos)
var
object oUIA,
object oElements,
object oCondition,
string sName,
handle hWindow = GetAppMainWindow (GetFocus())
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (hWindow)
If !oElements then Return EndIf
oCondition = oUIA.CreateIntPropertyCondition(UIA_ControlTypePropertyId, UIA_TextControlTypeId)
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)

If iPos == cPosition then
      if oElements.Count > 2 then
      sName = oElements(3).name
      else
      sName = oElements(0).name
      EndIf ; if oElements.Count > 2 then
EndIf ; If iPos == cPosition then

If iPos == cLengthOrRemainingTime then
      If !IsFileOpen () then
      SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNoFileOpen)
      SendToBraille (MsgNoFileOpen)
      Return
      EndIf 

      if oElements.Count > 2 then
      sName = oElements(4).name
      else
      sName = oElements(1).name
      EndIf ; if oElements.Count > 2 then

      If StringContains (sName, "-") then
      sName = StringReplaceSubstrings (sName, "-", MsgTimeRemaining)
      else
      sName = MsgTimeLength + sName 
      EndIf ; If StringContains (sName, "-") then
EndIf ; If iPos == cLengthOrRemainingTime then

If iPos == cFilename then
      If oElements.Count > 2 then
      sName = oElements(0).name
      else
      sName = MsgStatusBarInaktiv
      EndIf ; If oElements.Count > 2 then
EndIf ; If iPos == cFilename then

If iPos == cSpeed then
      if oElements.Count > 2 then
      sName = oElements(1).name
      else
      sName = MsgStatusBarInaktiv
      EndIf ; if oElements.Count > 2 then

sName = StringReplaceSubstrings (sName, "1.00x", MsgSpeed100)
sName = StringReplaceSubstrings (sName, "0.67x", MsgSpeed067)
sName = StringReplaceSubstrings (sName, "0.50x", MsgSpeed050)
sName = StringReplaceSubstrings (sName, "0.33x", MsgSpeed033)
sName = StringReplaceSubstrings (sName, "0.25x", MsgSpeed025)
sName = StringReplaceSubstrings (sName, "0.12x", MsgSpeed012)
sName = StringReplaceSubstrings (sName, "1.50x", MsgSpeed150)
sName = StringReplaceSubstrings (sName, "2.00x", MsgSpeed200)
sName = StringReplaceSubstrings (sName, "3.00x", MsgSpeed300)
sName = StringReplaceSubstrings (sName, "4.00x", MsgSpeed400)
sName = StringReplaceSubstrings (sName, "8.00x", MsgSpeed800)
sName = StringReplaceSubstrings (sName, "16.13x", MsgSpeed1613)
sName = StringReplaceSubstrings (sName, "31.25x", MsgSpeed3125)
sName = StringReplaceSubstrings (sName, "x", MsgSpeed0)
EndIf ; If iPos == cSpeed then

If iPos == cPositionOrRemainingTimeAndLength then
      If !IsFileOpen () then
      SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNoFileOpen)
      SendToBraille (MsgNoFileOpen)
      Return
      EndIf 

      if oElements.Count > 2 then
      sName = oElements(2).name
      else
      sName = MsgStatusBarInaktiv
      EndIf ; If iPos == cPositionOrRemainingTimeAndLength then

      If StringContains (sName, "-") then
      sName = MsgTimeRemaining  + sName
      else
      sName = MsgTimePos + sName
      EndIf ; If StringContains (sName, "-") then
      sName = StringReplaceSubstrings (sName, "/", MsgTimeLength)
EndIf ; If iPos == cPositionOrRemainingTimeAndLength then

Return sName
EndFunction

; cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
; Funktion zum berprfen des Fokus bzw. aktives Steuerelement
; cccccccccccccccccccccccccccccccccccccccccccccccccccccccc

; -----------------------------------------------------------------------------------------------
; VLC-Player-Anwendungsfenster
; -----------------------------------------------------------------------------------------------

int Function IsPlayerWindow ()
var
string sTitle = GetWindowName (GetRealWindow (GetFocus()))
If StringContains (sTitle, cPlayerWindowName) then
Return True
else 
Return False 
EndIf ; If sTitle == cPlayerWindowName then
EndFunction 

; -----------------------------------------------------------------------------------------------
; Dialog "Anpassungen und Effekte" 
; -----------------------------------------------------------------------------------------------

int Function IsDialogEffects ()
var
string sTitle = GetWindowName (GetRealWindow (GetFocus()))
If StringContains (sTitle, cDialogNameEffects) then
Return True
else 
Return False 
EndIf ; If sTitle == cPlayerWindowName then
EndFunction 

; -----------------------------------------------------------------------------------------------
; Dialog "Zu Zeitpunkt gehen" 
; -----------------------------------------------------------------------------------------------

int Function IsDialogGoTo ()
var
string sTitle = GetWindowName (GetRealWindow (GetFocus()))
If StringContains (sTitle, cDialogNameGoTo) then
Return True
else 
Return False 
EndIf ; If sTitle == cPlayerWindowName then
EndFunction 

; -----------------------------------------------------------------------------------------------
; Dialog "Aktuelle Medieninformationen"
; -----------------------------------------------------------------------------------------------

int Function IsDialogMediaInformation ()
If GetWindowName (GetRealWindow(GetFocus())) == cDialogNameMediaInfos then
Return True
else
Return False
EndIf ; If GetWindowName (GetRealWindow(GetFocus())) == cDialogNameMediaInfos then
EndFunction

; -----------------------------------------------------------------------------------------------
; Checkbox "Wiederholen" 
; -----------------------------------------------------------------------------------------------

int Function isRepeatCheckBox  (object oEntry)
var
object oPattern
oPattern = oEntry.GetLegacyIAccessiblePattern()
If oEntry.ControlType == UIA_CheckBoxControlTypeId 
&& oPattern.Description == cDescriptionCheckBoxRepeat then
Return True
else
Return False 
EndIf 
EndFunction 

; -----------------------------------------------------------------------------------------------
; Checkbox "Zufllig" 
; -----------------------------------------------------------------------------------------------

int  Function isRandomCheckBox  (object oEntry)
var
object oPattern
oPattern = oEntry.GetLegacyIAccessiblePattern()
If oEntry.ControlType == UIA_CheckBoxControlTypeId && oPattern.Description == cDescriptionCheckboxRandom then
Return True
else
Return False 
EndIf 
EndFunction 

; -----------------------------------------------------------------------------------------------
; Checkbox "Playist" 
; -----------------------------------------------------------------------------------------------

int  Function isPlaylistCheckBox  (object oEntry)
var
object oPattern
oPattern = oEntry.GetLegacyIAccessiblePattern()
If oEntry.ControlType == UIA_CheckBoxControlTypeId 
&& oPattern.Description == cDescriptionCheckboxPlaylist then
Return True
else
Return False 
EndIf 
EndFunction 

; -----------------------------------------------------------------------------------------------
; Checkbox "Aufnehmen" 
; -----------------------------------------------------------------------------------------------

int  Function isRecordingCheckBox  (object oEntry)
var
object oPattern
oPattern = oEntry.GetLegacyIAccessiblePattern()
If oEntry.ControlType == UIA_CheckBoxControlTypeId 
&& oPattern.Description == cDescriptionCheckBoxRecord then
Return True
else
Return False 
EndIf 
EndFunction 

; -----------------------------------------------------------------------------------------------
; Statusleiste
; -----------------------------------------------------------------------------------------------

int Function IsStatusBarActive ()
var
object oUIA,
object oElements,
object oCondition,
handle hWindow = GetAppMainWindow (GetFocus())
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (hWindow)
If !oElements then Return EndIf
oCondition = oUIA.CreateIntPropertyCondition(UIA_ControlTypePropertyId, UIA_TextControlTypeId)
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)

if oElements.Count > 2 then
Return True
else
Return False
EndIf 
EndFunction

; -----------------------------------------------------------------------------------------------
; Playliste
; -----------------------------------------------------------------------------------------------

int Function IsPlaylistActive ()
var
object oUIA,
object oElements,
object oCondition,
handle hWindow = GetAppMainWindow (GetFocus())
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (hWindow)
If !oElements then Return EndIf
oCondition = oUIA.CreateIntPropertyCondition(UIA_ControlTypePropertyId, UIA_EditControlTypeId)
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)

if oElements.Count > 0 then
Return True
else
Return False
EndIf ; if oElements.Count > 0 then
EndFunction

; -----------------------------------------------------------------------------------------------
; Stummschaltung 
; -----------------------------------------------------------------------------------------------

int Function IsMuting ()
var
object oUIA, 
object oXML,
object oElementList

oXML = CreateObject("msxml2.DOMDocument.6.0"); Einstellungen vornehmen 
oXML.async = false;
oXML.resolveExternals = false;
oXML.setProperty("SelectionLanguage", "XPath")
oUIA = GetMSAAObjectTree(GetAppMainWindow(GetFocus()))
; asdf
if !oUIA then 
Return 2
EndIf 
oXML.LoadXML(oUIA.GetXML(true))
oElementList = oXML.documentElement.selectNodes(cXPathMute)

If  oElementList.Length > 0 then
Return False
Else 
Return True
EndIf 
EndFunction 

; -----------------------------------------------------------------------------------------------
; Ist Datei geffnet
; -----------------------------------------------------------------------------------------------

int Function IsFileOpen ()
var
string sFilename = GetWindowName (GetAppMainWindow(GetFocus()))
If StringContains (sFileName, " - ") then
Return True
else
Return False
EndIf ; If StringContains (sFileName, " - ") then
EndFunction 

; -----------------------------------------------------------------------------------------------
; Ist Datei geffnet (erweiterte Prfung)
; -----------------------------------------------------------------------------------------------

int Function IsFileOpenEx ()
var
string sFilename
If !IsPlayerWindow () then Return False EndIf 
; Wenn Statuszeile ausgeblendet ist 
If !IsStatusBarActive () then
; Dateinamen aus Fenstertitel ermitteln 
sFileName = GetWindowText (GetAppMainWindow(GetFocus()), False)
      ; wenn ein Bindestrich existiert, ist ein Dateinamen vorhanden 
      If StringContains (sFileName, " - ") then
      Return True
      else
      ; andernfalls ist keien Datei geffnet 
      Return False 
      EndIf ; If StringContains (sFileName, " - ") then
else
; Statuszeile ist aktiv, also Dateinamen aus Statuszeile ermitteln 
sFilename = GetStaticText (cFilename)
      If sFilename == "" then 
      Return False 
      else
      Return True
      EndIf ; If sFilename == "" then
EndIf ; If !IsStatusBarActive () then
EndFunction 

; -----------------------------------------------------------------------------------------------
; Prft, ob die bergebene Checkbox ausgewhlt ist oder nicht 
; -----------------------------------------------------------------------------------------------

int Function IsCheckBoxChecked (object oCheckbox)
var
object oToggleState
oToggleState = oCheckbox.GetTogglePattern()
If oToggleState.toggleState == 1 then
Return True
else
Return False
EndIf 
EndFunction 

; cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
; Behandlung von Steuerelementen (Schaltflche, Checkbox)
; Der Name "FocussableUIAObject" rhrt daher, da nicht alle 
; UIA-Objekte verarbeitet werden, sondern lediglich Steuerelemente,
; welche den Fokus erhalten knnen (Schaltflchen, Checkboxen)
; cccccccccccccccccccccccccccccccccccccccccccccccccccccccc

; a) Beschreibung 

; -----------------------------------------------------------------------------------------------
; Sucht in den MSAA-Descriptions nach "sDescription" und gibt 
; die Nummer zurck
; Wenn der optionale Parameter "iPartOfString" True ist, muss 
; "sDescription" nicht komplett vorhanden sein (Suche nach 
; Teilstrings)
; -----------------------------------------------------------------------------------------------

int Function GetFocussableUIAObjectNumberWithMSAADescription (string sDescription, optional int iPartOfString)
var
object oUIA, 
object oElements, 
object oPattern, 
object oEntry, 
int i = -1,
string sActDescription, 
object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateOrCondition (oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId), oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId))

if (!oElements || !oCondition) return Null () endIf
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)

ForEach oEntry in oElements 
i = i + 1
oPattern = oEntry.GetLegacyIAccessiblePattern()
sActDescription = oPattern.Description

If iPartOfString then
      If StringContains (sActDescription, sDescription)
      Return i
      EndIf ; If StringContains (sActDescription, sDescription)
else
      If sActDescription == sDescription then
      return i
      EndIf ; If sActDescription == sDescription then
EndIf ; If iPartOfString then
EndForEach 
EndFunction 

; -----------------------------------------------------------------------------------------------
; Sucht in den MSAA-Descriptions nach "sDescription" und gibt 
; das UIA-Element-Objekt zurck
; Wenn der optionale Parameter "iPartOfString" True ist, muss 
; "sDescription" nicht komplett vorhanden sein (Suche nach 
; Teilstrings)
; -----------------------------------------------------------------------------------------------

object Function GetFocussableUIAObjectWithMSAADescription (string sDescription, optional int iPartOfString)
var
object oUIA, 
object oElements, 
object oPattern, 
object oEntry, 
string sActDescription, 
object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateOrCondition (oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId), oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId))

if (!oElements || !oCondition) return Null () endIf
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)

ForEach oEntry in oElements 
oPattern = oEntry.GetLegacyIAccessiblePattern()
sActDescription = oPattern.Description

If iPartOfString then
      If StringContains (sActDescription, sDescription)
      Return oEntry
      EndIf ; If StringContains (sActDescription, sDescription)
else
      If sActDescription == sDescription then
      return oEntry
      EndIf ; If sActDescription == sDescription then
EndIf ; If iPartOfString then
EndForEach 
EndFunction 

; -----------------------------------------------------------------------------------------------
; Sucht in den MSAA-Descriptions nach "sDescription" und fhrt
; dann die Standard-UIA-Aktion aus 
; Wenn der optionale Parameter "iPartOfString" True ist, muss 
; "sDescription" nicht komplett vorhanden sein (Suche nach 
; Teilstrings)
; -----------------------------------------------------------------------------------------------

int Function InvokeFocussableUIAObjectWithMSAADescription (string sDescription, optional int iPartOfString)
var
object oUIA, 
object oElements, 
object oPattern, 
object oEntry, 
string sActDescription, 
object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateOrCondition (oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId), oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId))

if (!oElements || !oCondition) return Null () endIf
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)

ForEach oEntry in oElements 
oPattern = oEntry.GetLegacyIAccessiblePattern()
sActDescription = oPattern.Description
AppendToClipboard (sActDescription, True)

If iPartOfString then
      If StringContains (sActDescription, sDescription)
      oEntry.GetInvokePattern().Invoke()
      Return True
      EndIf ; If StringContains (sActDescription, sDescription)
else
      If sActDescription == sDescription then
      oEntry.GetInvokePattern().Invoke()
      return True
      EndIf ; If sActDescription == sDescription then
EndIf ; If iPartOfString then
EndForEach 
Return False
EndFunction 

; -----------------------------------------------------------------------------------------------
; Sucht in den MSAA-Descriptions nach "sDescription" und fhrt
; dann einen Mausklick aus 
; Wenn der optionale Parameter "iPartOfString" True ist, muss 
; "sDescription" nicht komplett vorhanden sein (Suche nach 
; Teilstrings)
; -----------------------------------------------------------------------------------------------

int Function ClickFocussableUIAObjectWithMSAADescription (string sDescription, optional int iPartOfString)
var
object oUIA, 
object oElements, 
object oPattern, 
object oEntry, 
int x, 
int y,
string sActDescription, 
object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateOrCondition (oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId), oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId))

if (!oElements || !oCondition) return Null () endIf
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)

ForEach oEntry in oElements 
oPattern = oEntry.GetLegacyIAccessiblePattern()
sActDescription = oPattern.Description

If iPartOfString then
      If StringContains (sActDescription, sDescription)
      oEntry.GetClickablePoint (intRef(x), IntRef(y))
      ClickAtPoint (x, y)
      Return True
      EndIf ; If StringContains (sActDescription, sDescription)
else
      If sActDescription == sDescription then
      oEntry.GetClickablePoint (intRef(x), IntRef(y))
      ClickAtPoint (x, y)
      return True
      EndIf ; If sActDescription == sDescription then
EndIf ; If iPartOfString then
EndForEach 
Return False
EndFunction 

; -----------------------------------------------------------------------------------------------
; Sucht in den MSAA-Descriptions nach "sDescription" und 
; fokussiert das UIA-Objekt dann
; Wenn der optionale Parameter "iPartOfString" True ist, muss 
; "sDescription" nicht komplett vorhanden sein (Suche nach 
; Teilstrings)
; -----------------------------------------------------------------------------------------------

int Function SetFocusToFocussableUIAObjectWithMSAADescription (string sDescription, optional int iPartOfString)
var
object oUIA, 
object oElements, 
object oPattern, 
object oEntry, 
string sActDescription, 
object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateOrCondition (oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId), oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId))

if (!oElements || !oCondition) return Null () endIf
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)

ForEach oEntry in oElements 
oPattern = oEntry.GetLegacyIAccessiblePattern()
sActDescription = oPattern.Description

If iPartOfString then
      If StringContains (sActDescription, sDescription)
      oEntry.SetFocus ()
      Return True
      EndIf ; If StringContains (sActDescription, sDescription)
else
      If sActDescription == sDescription then
      oEntry.SetFocus ()
      return True
      EndIf ; If sActDescription == sDescription then
EndIf ; If iPartOfString then
EndForEach 
Return False
EndFunction 

; -----------------------------------------------------------------------------------------------
; Sucht in den MSAA-Descriptions nach "sDescription" und 
; fhrt eine Aktion aus (cActionInvoke, cActionSetFocus, 
; cActionMouseClick)
; Wenn der optionale Parameter "iPartOfString" True ist, muss 
; "sDescription" nicht komplett vorhanden sein (Suche nach 
; Teilstrings)
; -----------------------------------------------------------------------------------------------

int Function PerformActionOnFocussableUIAElementWithMSAADescription (int iAction, string sDescription, optional int iPartOfString)
var
object oUIA, 
object oElements, 
object oPattern, 
object oEntry, 
int x, 
int y,
string sActDescription, 
object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateOrCondition (oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId), oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId))

if (!oElements || !oCondition) return Null () endIf
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)

ForEach oEntry in oElements 
oPattern = oEntry.GetLegacyIAccessiblePattern()
sActDescription = oPattern.Description

If iPartOfString then
      If StringContains (sActDescription, sDescription)

            If iAction == cActionInvoke then
            oEntry.GetInvokePattern().Invoke ()
            EndIf ; If iAction == cActionInvoke then

            If iAction == cActionMouseClick then
            oEntry.GetClickablePoint (intRef(x), IntRef(y))
            ClickAtPoint (x, y)
            EndIf ; If iAction == cActionMouseClick then

            If iAction == cActionSetFocus then
            oEntry.SetFocus ()
            EndIf ; If iAction == cActionSetFocus then

      Return True
      EndIf ; If StringContains (sActDescription, sDescription)
else
      If sActDescription == sDescription then

            If iAction == cActionInvoke then
            oEntry.GetInvokePattern().Invoke ()
            EndIf ; If iAction == cActionInvoke then

            If iAction == cActionMouseClick then
            oEntry.GetClickablePoint (intRef(x), IntRef(y))
            ClickAtPoint (x, y)
            EndIf ; If iAction == cActionMouseClick then

            If iAction == cActionSetFocus then
            oEntry.SetFocus ()
            EndIf ; If iAction == cActionSetFocus then

      return True
      EndIf ; If sActDescription == sDescription then
EndIf ; If iPartOfString then
EndForEach 
Return False
EndFunction

; b) ber die Nummer (siehe auch "GetFocussableUIAObjectNumberWithMSAADescription"
; zum Ermitteln der Nummer ber die MSAA-Description

; -----------------------------------------------------------------------------------------------
; gibt UIA-Objekt anhand der Nummer zurck 
; (nur Schaltflchen und Checkboxen)
; -----------------------------------------------------------------------------------------------

object Function GetFocussableUIAObjectWithNumber (int iNumber)
var
object oUIA, 
object oElements, 
object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateOrCondition (oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId), oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId))

if (!oElements || !oCondition) return Null () endIf
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)
Return oElements(iNumber)
EndFunction 

; -----------------------------------------------------------------------------------------------
; fhrt den Invoke-Befehl fr das UIA-Objekt mit 
; der angegebenen Nummer aus (nur Schaltflchen und Checkboxen)
; -----------------------------------------------------------------------------------------------

int Function InvokeFocussableUIAObjectWithNumber (int iNumber)
var
object oUIA, 
object oElements, 
object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateOrCondition (oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId), oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId))

if (!oElements || !oCondition) return Null () endIf
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)
oElements(iNumber).GetInvokePattern().Invoke()
Return True 
EndFunction

; -----------------------------------------------------------------------------------------------
; fhrt einen Mausklick auf das UIA-Objekt mit 
; der angegebenen Nummer aus (nur Schaltflchen und Checkboxen)
; -----------------------------------------------------------------------------------------------

int Function ClickFocussableUIAObjectWithNumber (int iNumber)
var
object oUIA, 
object oElements, 
object oCondition, 
int x, 
int y

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateOrCondition (oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId), oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId))

if (!oElements || !oCondition) return Null () endIf
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)
oElements(iNumber).GetClickablePoint (intRef(x), IntRef(y))
ClickAtPoint (x, y)
Return True 
EndFunction

; -----------------------------------------------------------------------------------------------
; Setzt den Fokus auf das UIA-Objekt mit 
; der angegebenen Nummer aus (nur Schaltflchen und Checkboxen)
; -----------------------------------------------------------------------------------------------

int Function SetFocusToFocussableUIAObjectWithNumber (int iNumber)
var
object oUIA, 
object oElements, 
object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateOrCondition (oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId), oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId))

if (!oElements || !oCondition) return Null () endIf
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)
oElements(iNumber).SetFocus ()
Return True 
EndFunction 

; -----------------------------------------------------------------------------------------------
; fhrt die in "iAction" angegebene Aktion auf das UIA-Objekt mit 
; der angegebenen Nummer aus (nur Schaltflchen und Checkboxen)
; -----------------------------------------------------------------------------------------------

int Function PerformActionOnFocussableUIAElementWithNumber (int iAction, int iNumber)
var
object oUIA, 
object oElements, 
object oCondition, 
int x, 
int y

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateOrCondition (oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId), oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId))

if (!oElements || !oCondition) return Null () endIf
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)

If iAction == cActionInvoke then
oElements(iNumber).GetInvokePattern().Invoke ()
Return True 
EndIf ; If iAction == cActionInvoke then

If iAction == cActionMouseClick then
oElements(iNumber).GetClickablePoint (intRef(x), IntRef(y))
ClickAtPoint (x, y)
Return True 
EndIf ; If iAction == cActionMouseClick then

If iAction == cActionSetFocus then
oElements(iNumber).SetFocus ()
Return True 
EndIf ; If iAction == cActionSetFocus then
Return False
EndFunction 

; -----------------------------------------------------------------------------------------------
; gibt die Anzahl der Schaltflchen (im Player-Fenster) zurck
; Anmerkung: Schaltflchen zum Umschalten (Zufall, Wiedergabe usw.)
; sind eigentlich CheckBoxen, die hier auch mit gezhlt werden 
; -----------------------------------------------------------------------------------------------

int Function GetFocussableUIAObjectsCount ()
var
object oUIA, 
object oElements, 
object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateOrCondition (oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId), oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId))

if (!oElements || !oCondition) return Null () endIf
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)
Return oElements.count
EndFunction

; -----------------------------------------------------------------------------------------------
; gibt Anhand der (Schaltflchen-)Nummer  den MSAA
; Beschreibungstext (Description) zurck 
; Zhlung beginnt mit 0 
; -----------------------------------------------------------------------------------------------

string Function GetDescriptionFromNumber (int iNumber, optional int iStatus)
var
object oUIA, 
object oElements, 
object oPattern, 
object oEntry, 
int i = -1,
string sActDescription, 
object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateOrCondition (oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId), oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId))

if (!oElements || !oCondition) return Null () endIf
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)

ForEach oEntry in oElements 
i = i + 1
oPattern = oEntry.GetLegacyIAccessiblePattern()
sActDescription = oPattern.Description

if !oEntry.IsEnabled && iStatus then 
sActDescription = sActDescription + MsgDisabled
EndIf

if i == iNumber then
Return sActDescription
EndIf 

EndForEach 
EndFunction

; cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
; Registerkarten-Setuerlemente (und hnliche)
; cccccccccccccccccccccccccccccccccccccccccccccccccccccccc

; -----------------------------------------------------------------------------------------------
; gibt die Namen aller Registerkarten zurck
; -----------------------------------------------------------------------------------------------

string Function GetTabNames ()
var
object oUIA, 
object oElements, 
object oCondition, 
object oEntry, 
string sTemp,
string sAll
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus()))
If !oElements then Return EndIf 
oCondition = oUIA.CreateIntPropertyCondition(UIA_ControlTypePropertyId, UIA_TabItemControlTypeId)
If !oCondition then Return EndIf 
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)
If !oElements then Return EndIf 
ForEach oEntry in oElements
sTemp = oEntry.name
sAll = sAll + sTemp + "|"
EndForEach
sAll = StringLeft (sAll, StringLength (sAll)-1)
Return sAll
EndFunction

; -----------------------------------------------------------------------------------------------
; fhrt einen Mausklick auf der Registerkarte (iNumber) aus
; -----------------------------------------------------------------------------------------------

int Function SelectTabByNumber (int iNumber)
var
object oUIA, 
object oElements, 
object oCondition, 
object oEntry, 
int i, 
int x, int y

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus()))
If !oElements then Return EndIf 
oCondition = oUIA.CreateIntPropertyCondition(UIA_ControlTypePropertyId, UIA_TabItemControlTypeId)
If !oCondition then Return EndIf 
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)
If !oElements then Return EndIf 
i = 0
ForEach oEntry in oElements
i = i + 1
If i == iNumber then
oEntry.GetClickablePoint (intRef(x), IntRef(y))
ClickAtPoint (x, y)
Return True
EndIf 
EndForEach
EndFunction

; -----------------------------------------------------------------------------------------------
; gibt die Namen aller Registerkarten (als Checkbox getarnt) zurck
; -----------------------------------------------------------------------------------------------

string Function GetCheckBoxTabNames ()
var
object oUIA, 
object oElements, 
object oCondition, 
object oEntry, 
int i, 
string sTemp,
string sAll
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus()))
If !oElements then Return EndIf 
oCondition = oUIA.CreateIntPropertyCondition(UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId)
If !oCondition then Return EndIf 
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)
If !oElements then Return EndIf 
i = 0
; Schleife ber alle Registerkarten 
ForEach oEntry in oElements
i = i + 1
sTemp = oEntry.name
sAll = sAll + sTemp + "|"
if i == 6 then
sAll = StringLeft (sAll, StringLength (sAll)-1)
Return sAll
EndIf ; if i == 6 then
EndForEach
EndFunction

; -----------------------------------------------------------------------------------------------
; fhrt einen Mausklick auf der Registerkarte (iNumber) aus
; -----------------------------------------------------------------------------------------------

int Function SelectCheckBoxByTabNumber (int iNumber)
var
object oUIA, 
object oElements, 
object oCondition, 
object oEntry, 
int i, 
int x, int y

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus()))
If !oElements then Return EndIf 
oCondition = oUIA.CreateIntPropertyCondition(UIA_ControlTypePropertyId, UIA_CheckBoxControlTypeId)
If !oCondition then Return EndIf 
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)
If !oElements then Return EndIf 
i = 0
ForEach oEntry in oElements
i = i + 1
If i == iNumber then
oEntry.GetClickablePoint (intRef(x), IntRef(y))
ClickAtPoint (x, y)
Return True
EndIf 
EndForEach
EndFunction

; cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
; Sonstiges
; cccccccccccccccccccccccccccccccccccccccccccccccccccccccc

; -----------------------------------------------------------------------------------------------
; kndigt nach Drcken von Tab, Shift+Tab und Enter 
; die Schaltflche an (Beschreibung, Deaktiviert usw.)
; -----------------------------------------------------------------------------------------------

void Function SayTabPosition (optional int iStatus)
var
string sDescription = GetDescriptionFromNumber (giTabPosition, true)
SayFormattedMessage (OT_SCREEN_MESSAGE, sDescription)
SendToBraille (sDescription)
EndFunction 

; -----------------------------------------------------------------------------------------------
; Liste der zuletzt geffneten Dateien ermitteln 
; -----------------------------------------------------------------------------------------------

string Function GetRecentFileList ()
var
object oUIA, 
object oXML,
string sResult,
string sValue,
int iCount, 
int i,
object oElementList

oXML = CreateObject("msxml2.DOMDocument.6.0")
; Einstellungen vornehmen 
oXML.async = false
oXML.resolveExternals = false
oXML.setProperty("SelectionLanguage", "XPath")
oUIA = GetMSAAObjectTree(GetAppMainWindow(GetFocus()))
if !oUIA then Return "" EndIf 
oXML.LoadXML(oUIA.GetXML(true))

oElementList = oXML.documentElement.selectNodes(cXPathFiles)
iCount = oElementList.Length - 1

for i = 0 to iCount
var object oAttribs = oElementList(i).attributes
sValue = oAttribs.GetNamedItem("Name").nodeValue
If StringContains (sValue, ":") then
sResult = sResult + sValue + "|"
EndIf 
Endfor
sResult = StringLeft (sResult, StringLength (sResult)-1)
sResult = StringReplaceChars (sResult, "/", "\\")
Return sResult
EndFunction 

; -----------------------------------------------------------------------------------------------
; zeigt Text auf der Braille-Zeile an
; -----------------------------------------------------------------------------------------------

void Function SendToBraille (string sMessage)
giUseFlashMessage = GetNonJCFOption("UseFlashMessageForVLC")
If giUseFlashMessage then
BrailleMessage (sMessage)
else
BrailleString (sMessage)
EndIf 
EndFunction

; -----------------------------------------------------------------------------------------------
; Event wird ausgelst, sobald eine Taste gedrckt wird 
; -----------------------------------------------------------------------------------------------

Void Function ProcessKeyPressed (int nKey, string strKeyName, int nIsBrailleKey, int nIsScriptKey)
var
int iMuting
if IsPlayerWindow () && !IsPlaylistActive () then
  if !nIsScriptKey then 
  var
  object oCheckbox 
  If nKey == cKeyM then 
     ; wenn die VLC-Taste fr Stummschaltung gedrckt wird 
    iMuting = IsMuting ()
    If iMuting == cMutingOff then
      SayFormattedMessage (OT_SCREEN_MESSAGE, MsgMutingOff)
      SendToBraille (MsgMutingOff)
    EndIf ; If iMuting == cMutingOff then
    If iMuting == cMutingOn then
      SayFormattedMessage (OT_SCREEN_MESSAGE, MsgMutingOn)
      SendToBraille (MsgMutingOn)
    EndIf ; If iMuting == cMutingOn then
    If iMuting == cMutingError then
      SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNoUIA)
      SendToBraille (MsgNoUIA)
    EndIf ; If iMuting == cMutingError then
    return 
  elIf nKey == cKeyR then 
     ; wenn die VLC-Taste fr Zufallswiedergabe gedrckt wird 
    oCheckbox = GetFocussableUIAObjectWithMSAADescription (cDescriptionCheckBoxRandom)
    If !oCheckBox then Return EndIf 
     ; oCheckBox.SetFocus ()
    If IsCheckBoxChecked (oCheckBox) then
      SayFormattedMessage (OT_SCREEN_MESSAGE, MsgRandomOn)
      SendToBraille (MsgRandomOn)
    else
      SayFormattedMessage (OT_SCREEN_MESSAGE, MsgRandomOff)
      SendToBraille (MsgRandomOff)
    EndIf ; If IsCheckBoxChecked (oCheckBox) then
    return
  elIf nKey == cKeyL then 
      ; wenn die VLC-Taste fr Wiederholungsmodus gedrckt wird 
      ; Checkbox-Objekt erhalten
     oCheckbox = GetFocussableUIAObjectWithMSAADescription (cDescriptionCheckBoxRepeat)
     If !oCheckBox then Return EndIf 
      ; oCheckBox.SetFocus ()
    Pause ()
     ; neuen Checkbox-Status ermitteln und global speichern 
    If IsCheckBoxChecked (oCheckBox) then
      giNewState = True
    else
      giNewState = False
    EndIf 
     ; Auswerten des "alten" und "neuen" Checkbox-Status
     ; (alter Status wird beim Programmstart ermittelt, sowie 
     ; anschlieend neu gesetzt)
    If giOldState && giNewState then
      SayFormattedMessage (OT_SCREEN_MESSAGE, MsgRepeatFile)
      SendToBraille (MsgRepeatFile)
    elIf giOldState && !giNewState then
      SayFormattedMessage (OT_SCREEN_MESSAGE, MsgRepeatNothing)
      SendToBraille (MsgRepeatNothing)
    elIf !giOldState && giNewState then
      SayFormattedMessage (OT_SCREEN_MESSAGE, MsgRepeatPlaylist)
      SendToBraille (MsgRepeatPlaylist)
    EndIf 
     ; alten Checkbox-Status fr den nchsten Aufruf global speichern 
    oCheckbox = GetFocussableUIAObjectWithMSAADescription (cDescriptionCheckBoxRepeat)
    giOldState = giNewState
    return
  endif
  endif ; !nIsScriptKey 
endif ; IsPlayerWindow () && !IsPlaylistActive () 
; Event an andere Dateien weiterreichen 
ProcessKeyPressed (nKey, strKeyName, nIsBrailleKey, nIsScriptKey)
EndFunction

; -----------------------------------------------------------------------------------------------
; Programmstart
; -----------------------------------------------------------------------------------------------

void Function AutoStartEvent ()
var
object oCheckbox = GetFocussableUIAObjectWithMSAADescription (cDescriptionCheckBoxRepeat)

ghPlayer = FindWindow (0, "", cPlayerWindowName)
giUseFlashMessage = GetNonJCFOption("UseFlashMessageForVLC")

; alten Checkbox-Status ermitteln und speichern 
If IsCheckBoxChecked (oCheckBox) then
giOldState = True
else
giOldState = False
EndIf 
EndFunction 

; xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
; Scripts
; xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

; cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
; Ansagen von Infos (statischer Text)
; cccccccccccccccccccccccccccccccccccccccccccccccccccccccc

; -----------------------------------------------------------------------------------------------
; aktuelle Position (links vom Schieberegler) 
; -----------------------------------------------------------------------------------------------

Script SayPosition ()
var
string sTemp
If !IsPlayerWindow () then Return EndIf 

sTemp = GetStaticText (cPosition)
SayFormattedMessage (OT_SCREEN_MESSAGE, sTemp)
SendToBraille (sTemp)
EndScript

; -----------------------------------------------------------------------------------------------
; verbleibende Zeit/Gesamtlnge (rexhts vom Schieberegler)
; -----------------------------------------------------------------------------------------------

Script SayLengthOrRemainingTime ()
var
string sTemp
If !IsPlayerWindow () then Return EndIf 
sTemp = GetStaticText (cLengthOrRemainingTime)
SayFormattedMessage (OT_SCREEN_MESSAGE, sTemp)
SendToBraille (sTemp)
EndScript

; -----------------------------------------------------------------------------------------------
; Wenn Statuszeile aktiv: Ansage des Dateinamens
; -----------------------------------------------------------------------------------------------

Script SayFilename ()
var
string sFilename
If !IsPlayerWindow () then Return EndIf 

; Wenn Statuszeile ausgeblendet ist 
If !IsStatusBarActive () then
; Dateinamen aus Fenstertitel ermitteln 
sFileName = GetWindowText (GetAppMainWindow(GetFocus()), False)
       ; wenn ein Bindestrich existiert, ist ein Dateinamen vorhanden 
      If StringContains (sFileName, " - ") then
      sFileName = StringSegment (sFileName, " - ", 1)
      else
       ; andernfalls ist keien Datei geffnet 
      sFileName = MsgNoFileOpen
      EndIf ; If StringContains (sFileName, " - ") then
else
; Statuszeile ist aktiv, also Dateinamen aus Statuszeile ermitteln 
sFilename = GetStaticText (cFilename)
; Wenn dort kein Text ist, ist keine Datei geffnet
If sFilename == "" then sFilename = MsgNoFileOpen endIf 
EndIf ; If !IsStatusBarActive () then
; Dateinamen sprechen 
SayFormattedMessage (OT_SCREEN_MESSAGE, sFilename)
SendToBraille (sFilename)
EndScript


; -----------------------------------------------------------------------------------------------
; Wenn Statuszeile aktiv: Ansage der Wiedergabegeschwindigkeit
; -----------------------------------------------------------------------------------------------

Script SaySpeed ()
var
string sTemp
If !IsPlayerWindow () then Return EndIf 
If !IsStatusBarActive () then
SayFormattedMessage (OT_ERROR , MsgStatusBarInaktiv)
SendToBraille (MsgStatusBarInaktiv)
Return
EndIf ; If !IsStatusBarActive () then
sTemp = GetStaticText (cSpeed)
SayFormattedMessage (OT_SCREEN_MESSAGE, sTemp)
SendToBraille (sTemp)
EndScript

; -----------------------------------------------------------------------------------------------
; Wenn Statuszeile aktiv: Ansage der verbleibenden Zeit/Position
; und Gesamtlnge
; -----------------------------------------------------------------------------------------------

Script SayPositionOrRemainingTimeAndLength ()
var
string sTemp
If !IsPlayerWindow () then Return EndIf 
If !IsStatusBarActive () then
SayFormattedMessage (OT_ERROR, MsgStatusBarInaktiv)
SendToBraille (MsgStatusBarInaktiv)
Return
EndIf ; If !IsStatusBarActive () then
sTemp = GetStaticText (cPositionOrRemainingTimeAndLength)
SayFormattedMessage (OT_SCREEN_MESSAGE, sTemp)
SendToBraille (sTemp)
EndScript

; cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
; Einstellungen im Player-Fenster selbst ndern 
; cccccccccccccccccccccccccccccccccccccccccccccccccccccccc

; -----------------------------------------------------------------------------------------------
; Anzeigeeinstellung in der Positionsanzeige umschalten 
; zwischen verbleibender Zeit und Gesamtlnge
; -----------------------------------------------------------------------------------------------

Script ChangeTimeDisplay ()
If !IsPlayerWindow () then Return EndIf 
var
object oUIA,
object oElements,
object oEntry, 
object oCondition,
int x, 
int y,
string sName,
handle hWindow = GetAppMainWindow (GetFocus())

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (hWindow)
If !oElements then Return EndIf
oCondition = oUIA.CreateIntPropertyCondition(UIA_ControlTypePropertyId, UIA_TextControlTypeId)
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)

if oElements.Count > 2 then
oEntry = oElements (4)
else
oEntry = oElements (1)
EndIf
sName = oEntry.Name
oEntry.GetClickablePoint (intRef(x), IntRef(y))
ClickAtPoint (x, y)

If StringContains (sName, "-") then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgChangeTimeDisplayTotalLength )
SendToBraille (MsgChangeTimeDisplayTotalLength )
else
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgChangeTimeDisplayRemainingTime)
SendToBraille (MsgChangeTimeDisplayRemainingTime)
EndIf  ; If StringContains (sName, "-") then
EndScript

; -----------------------------------------------------------------------------------------------
; Anzeigeeinstellung in der Statuszeile umschalten 
; zwischen aktueller Position und verbleibender Zeit 
; -----------------------------------------------------------------------------------------------

Script ChangeTimeDisplayStatusBar ()
If !IsPlayerWindow () then Return EndIf 
var
object oUIA,
object oElements,
object oEntry,
object oCondition,
int x, 
int y,
string sName,
handle hWindow = GetAppMainWindow (GetFocus())

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (hWindow)
If !oElements then Return EndIf
oCondition = oUIA.CreateIntPropertyCondition(UIA_ControlTypePropertyId, UIA_TextControlTypeId)
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)

if oElements.Count > 2 then
oEntry = oElements(2)
oEntry.GetClickablePoint (intRef(x), IntRef(y))
sName = oEntry.Name 
ClickAtPoint (x, y)
      If StringContains (sName, "-") then
      SayFormattedMessage (OT_SCREEN_MESSAGE, MsgChangeTimeDisplayStatusbarPosition)
      SendToBraille (MsgChangeTimeDisplayStatusbarPosition)
      else
      SayFormattedMessage (OT_SCREEN_MESSAGE, MsgChangeTimeDisplayStatusbarRemainingTime)
      SendToBraille (MsgChangeTimeDisplayStatusbarRemainingTime)
      EndIf ; If StringContains (sName, "-") then
else
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgStatusBarChangeInaktiv)
SendToBraille (MsgStatusBarChangeInaktiv)
Return
EndIf
EndScript 

; -----------------------------------------------------------------------------------------------
; Wiedergabegeschwindigkeit ndern (langsamer)
; Standard-Taste (-) ist in JAWS selbst vergeben, deshalb 
; nderung auf Strg+Windows+Minus
; -----------------------------------------------------------------------------------------------

Script ChangeSpeedSlower ()
If !IsPlayerWindow () then Return EndIf 
TypeKey ("NumPadMinus")
Pause ()
PerformScript SaySpeed ()
EndScript 

; -----------------------------------------------------------------------------------------------
; Wiedergabegeschwindigkeit ndern (schneller)
; Standard-Taste (+) ist in JAWS selbst vergeben, deshalb 
; nderung auf Strg+Windows+Plus
; -----------------------------------------------------------------------------------------------

Script ChangeSpeedFaster ()
If !IsPlayerWindow () then Return EndIf 
TypeKey ("NumpadPlus")
Pause ()
PerformScript SaySpeed ()
EndScript 

; -----------------------------------------------------------------------------------------------
; Schaltet zwischen Player-Ansicht und Playlist-Ansicht um 
; -----------------------------------------------------------------------------------------------

Script ChangePlayerPlaylistView ()
If IsPlayerWindow () then 
var
object oButtonPlaylist = GetFocussableUIAObjectWithMSAADescription (cDescriptionButtonPlayList)
Pause ()
oButtonPlaylist.SetFocus()
oButtonPlaylist.GetInvokePattern().Invoke
Pause ()
      If IsPlaylistActive () then
      SayFormattedMessage (OT_SCREEN_MESSAGE, MsgPlaylist)
      SendToBraille (MsgPlaylist)
            If GetNonJCFOption("UseTutorMessagesForVLC") then
           SayFormattedMessage (OT_SCREEN_MESSAGE, MsgPlaylistWarning)
            EndIf 
      else
      SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNoPlaylist)
      SendToBraille (MsgNoPlaylist)
      EndIf ; If IsPlaylistActive () then
else
TypeCurrentScriptKey ()
EndIf ; If IsPlayerWindow () then 
EndScript 

; -----------------------------------------------------------------------------------------------
; Geffnete Dialoge (Fenster) in einem Dialog anzeigen 
; -----------------------------------------------------------------------------------------------

Script ShowOpenDialogsInList ()
var
handle hWindow,
string sClass, 
string sName, 
string sList, 
string sHandles,
int iHandle, 
int iIndex, 
int iResult

Pause ()
Delay (5)

sName = GetWindowClass(GetRealWindow(GetFocus()))
sName = GetWindowName (GetRealWindow(GetFocus()))
;hWindow = FindWindow (0, "", cPlayerWindowName)
hWindow = GetAppMainWindow (GetFocus())

If !hWindow then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNoPlayerWindow)
SendToBraille (MsgNoPlayerWindow)
Return
else
SetFocus (hWindow)
sList = cPlayerDisplayName + "|"
sHandles = IntToString (hWindow) + "|"
EndIf 

Pause()

hWindow = FindWindow (0, "", cDialogNameEffects)
If hWindow && IsWindowVisible (hWindow) then 
sList = sList + cDialogNameEffects + "|"
sHandles = sHandles + IntToString (hWindow) + "|"
EndIf ; If hWindow then

Pause()

hWindow = FindWindow (0, "", cDialogNameBookmarks)
If hWindow && IsWindowVisible (hWindow) then 
sList = sList + cDialogNameBookmarks + "|"
sHandles = sHandles + IntToString (hWindow) + "|"
EndIf ; If hWindow then

Pause()

hWindow = FindWindow (0, "", cDialogNameGoTo)
If hWindow && IsWindowVisible (hWindow) then 
sList = sList + cDialogNameGoTo + "|"
sHandles = sHandles + IntToString (hWindow) + "|"
EndIf ; If hWindow then

hWindow = GetAppMainWindow(GetFocus())
while hWindow
hWindow = GetNextWindow (hWindow) 
sClass = GetWindowClass (hWindow)
sName = GetWindowName (hWindow)

      if (sClass == cQWidgetClass) || (sClass == cQToolClass) || (sClass == cQWindowIcon) then
                If !(sName  == cCommonWindowName) && IsWindowVisible (hWindow) then
                sList = sList + sName + "|"
                sHandles = sHandles + IntToString (hWindow) + "|"
                EndIf ; If !(sName  == cCommonWindowName) then
      EndIf ; if (sClass == cQWidgetClass) || (sClass == cQToolClass) then
EndWhile

iIndex = 1
If StringSegmentCount (sList, "|") == 1 then 
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNoWindowsOpen)
SendToBraille (MsgNoWindowsOpen)
Return 
EndIf 

iResult = DlgSelectItemInList (sList, MsgDlgWindowsTitle, False, iIndex)

If iResult then
iHandle = StringToInt (StringSegment (sHandles, "|", iResult))
SetFocus (iHandle)
EndIf ; If iResult then 
EndScript 

; -----------------------------------------------------------------------------------------------
; Die zuletzt abgespielten Dateien in einem Dialog anzeigen 
; -----------------------------------------------------------------------------------------------

Script ShowRecentFilelist ()
var
string sFileList = GetRecentFileList (),
int iResult,
string sResult

if sFileList == "" then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNoRecentFilelist)
SendToBraille (MsgNoRecentFilelist)
Return
EndIf 

iResult = DlgSelectItemInList (sFileList, MsgDlgRecentFileTitle, False, 1)

if iResult then
sResult = StringSegment (sFileList, "|", iResult)
sResult = StringSegment (sResult, ":", 1)
EndIf 

TypeKey("Control+"+sResult)
EndScript 

; -----------------------------------------------------------------------------------------------
; zeigt einen Auswahldialog mit Registerkarteneintrgen an 
; -----------------------------------------------------------------------------------------------

Script ShowTabItems ()
var 
int iResult,
string sDialogTitle = GetWindowName (GetRealWindow(GetFocus()))
if sDialogTitle == cDialogNameSimplePreferences then
iResult = DlgSelectItemInList (GetCheckBoxTabNames(), cTabControlsTitle, False, 1)
Pause ()
SelectCheckBoxByTabNumber (iResult)
else
iResult = DlgSelectItemInList (GetTabNames(), cTabControlsTitle, False, 1)
Pause ()
SelectTabByNumber (iResult)
EndIf 
EndScript

; cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
; Vlc-Tasten und Standardtasten ausfhren 
; (und ggf. nderung ankndigen)
; cccccccccccccccccccccccccccccccccccccccccccccccccccccccc

; -----------------------------------------------------------------------------------------------
; Lautstrke erhhen (Wert ist leider nicht zu ermitteln) 
; -----------------------------------------------------------------------------------------------

Script VLCControlUpArrow ()
TypeCurrentScriptKey ()
If !IsPlayerWindow () then Return EndIf 
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgVolumeUp)
SendToBraille (MsgVolumeUp)
EndScript 

; -----------------------------------------------------------------------------------------------
; Lautstrke verringern (Wert ist leider nicht zu ermitteln) 
; -----------------------------------------------------------------------------------------------

Script VLCControlDownArrow ()
TypeCurrentScriptKey ()
If !IsPlayerWindow () then Return EndIf 
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgVolumeDown)
SendToBraille (MsgVolumeDown)
EndScript 

; -----------------------------------------------------------------------------------------------
; Kontextmentasten 
; -----------------------------------------------------------------------------------------------

Script ShowContextMenu ()
TypeCurrentScriptKey ()
If !IsPlayerWindow () then Return EndIf 
var
object oButton = GetFocussableUIAObjectWithMSAADescription ("Wiedergabe stoppen"),
int x, 
int y
oButton.GetClickablePoint (intRef(x), IntRef(y))
JAWSCursor ()
MoveTo (x, y)
RightMouseButton ()
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgApplication)
SendtoBraille (MsgApplication)
PCCursor ()
EndScript 

; -----------------------------------------------------------------------------------------------
; Position ndern mit VLC-Tasten ndern (zurck- bzw. vorspulen)
; -----------------------------------------------------------------------------------------------

Script ChangePosition ()
; Taste zum ndern der Geschwindigkeit an VLC weiterreichen 
TypeCurrentScriptKey ()
; Wenn wir im Player-Fenster sind 
If !IsPlayerWindow () then Return EndIf 
; eine halbe Sekunde warten, bis die Position vom VLC berechnet wurde und angezeigt wird 
Delay (5)
; Position sprechen 
PerformScript SayPosition ()
EndScript 

; -----------------------------------------------------------------------------------------------
; Setzt im Player-Fenster den Fokus auf die nchste Schaltflche 
; -----------------------------------------------------------------------------------------------

Script VLCTab ()

If !GetNonJCFOption("FocusWithTab") then 
TypeCurrentScriptKey ()
Return 
EndIf ; If !GetNonJCFOption("FocusWithTab") then 

var
object oUIA, 
object oElements, 
object oCondition, 
int x, 
int y


If giInCommentsEdit then
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_EditControlTypeId) 
if (!oElements || !oCondition) return endIf
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)
; SetFocus ist nicht mglich, deshalb klickbare Position ermitteln 
; (deshalb mit oCondition nach Eingabefeldern suchen, da ein 
; Klick auf eine Schaltflche diese ausfhren wrde)
oElements(0).GetClickablePoint (intRef(x), IntRef(y))
ClickAtPoint (x, y)
Return
EndIf 

; Dialog "Zu Zeitpunkt gehen"
If IsDialogGoTo () then
TypeCurrentScriptKey ()
Return
EndIf 

If !IsPlayerWindow ()  || IsPlaylistActive () then 
TypeCurrentScriptKey ()
Return 
EndIf 

giTabPosition = giTabPosition + 1
If giTabPosition == GetFocussableUIAObjectsCount () 
|| giTabPosition > GetFocussableUIAObjectsCount ()  then
; erste 3 Elemente berspringen 
giTabPosition = 5
EndIf 
SetFocusToFocussableUIAObjectWithNumber (giTabPosition)
SayTabPosition ()
EndScript 

; -----------------------------------------------------------------------------------------------
; Setzt im Player-Fenster den Fokus auf die vorherige Schaltflche 
; -----------------------------------------------------------------------------------------------

Script VLCShiftTab ()

If !GetNonJCFOption("FocusWithTab") then 
TypeCurrentScriptKey ()
Return 
EndIf ; If !GetNonJCFOption("FocusWithTab") then 

If !IsPlayerWindow ()  || IsPlaylistActive () then 
TypeCurrentScriptKey ()
Return 
EndIf 

; Dialog "Zu Zeitpunkt gehen"
If IsDialogGoTo () then
TypeCurrentScriptKey ()
Return
EndIf 


giTabPosition = giTabPosition - 1
; erste 5 Elemente berspringen 
If giTabPosition == 4 then
giTabPosition = GetFocussableUIAObjectsCount () - 1
EndIf 
SetFocusToFocussableUIAObjectWithNumber (giTabPosition)
SayTabPosition ()
EndScript 


; -----------------------------------------------------------------------------------------------
; Fhrt im Player-Fenster Schaltflchen aus 
; -----------------------------------------------------------------------------------------------

Script VLCEnter ()
If !GetNonJCFOption("FocusWithTab") then 
TypeCurrentScriptKey ()
Return 
EndIf ; If !GetNonJCFOption("FocusWithTab") then 

If IsDialogMediaInformation () then
var
object oUIA, 
object oElement, 
object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElement = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
oCondition = oUIA.CreateStringPropertyCondition (UIA_NamePropertyId, "Metadaten speichern") 
if (!oElement || !oCondition) return endIf
oElement = oElement.FindFirst (TreeScope_Descendants, oCondition)
; wenn die Suche erfolgreich war und wir nicht im Kommentar-Eingabefeld sind 
If oElement && giInCommentsEdit == False then
; Schaltflche zum Speichern ausfhren
oElement.GetInvokePattern().Invoke()
else
TypeCurrentScriptKey ()
Return
EndIf 

EndIf 


If !IsPlayerWindow ()  || IsPlaylistActive () then 
TypeCurrentScriptKey ()
Return 
EndIf 

SetFocusToFocussableUIAObjectWithNumber  (giTabPosition)

If GetDescriptionFromNumber (giTabPosition)  == cDescriptionButtonPlayList then
PerformScript ChangePlayerPlaylistView ()
Return
EndIf 

If GetDescriptionFromNumber (giTabPosition)  == cDescriptionCheckBoxRepeat then
PerformScript ChangeRepeat ()
Return
EndIf 

If GetDescriptionFromNumber (giTabPosition)  == cDescriptionCheckBoxRandom then
PerformScript ChangeRandom ()
Return
EndIf 

InvokeFocussableUIAObjectWithNumber (giTabPosition)
SayTabPosition (True)
EndScript 

; -----------------------------------------------------------------------------------------------
; Zeigt den Dialog "Anpassungen und Effekte" an oder aktiviert ihn
; -----------------------------------------------------------------------------------------------

Script ShowDialogEffects ()
var
handle hDialog = FindWindow (0, "", cDialogNameEffects)

; Dialog hat noch kein Handle (beim Programmstart)
If hDialog == 0 then
; also Strg+E an VLC senden um es anzuzeigen 
TypeCurrentScriptKey ()
; Befehle verarbeiten 
Delay (5)
Pause ()
; Dialog-Handle neu bestimmen 
hDialog = FindWindow (0, "", cDialogNameEffects)
; um dann das Fenster fokussieren 
SetFocus (hDialog)
Return
EndIf 

; Wenn der Dialog schon erzeugt ist, jedoch vom VLC ausgeblendet wurde 
If IsWindowVisible (hDialog) == False then
; Skript-Taste senden um ihn anzuzeigen 
TypeCurrentScriptKey ()
EndIf 

; Dialog aktivieren 
SetFocus (hDialog)

EndScript 

; -----------------------------------------------------------------------------------------------
; Zeigt den Dialog "Anpassungen und Effekte" an oder aktiviert ihn
; -----------------------------------------------------------------------------------------------

Script ShowDialogMediaInfos ()
var
handle hDialog = FindWindow (0, "", cDialogNameMediaInfos)
; Dialog hat noch kein Handle (beim Programmstart)
If hDialog == 0 then
; also Strg+E an VLC senden um es anzuzeigen 
TypeCurrentScriptKey ()
; Befehle verarbeiten 
Pause ()
; Dialog-Handle neu bestimmen 
hDialog = FindWindow (0, "", cDialogNameMediaInfos)
; um dann das Fenster fokussieren 
SetFocus (hDialog)
Return
EndIf 

; Wenn der Dialog schon erzeugt ist, jedoch vom VLC ausgeblendet wurde 
If IsWindowVisible (hDialog) == False then
; Skript-Taste senden um ihn anzuzeigen 
TypeCurrentScriptKey ()
EndIf 

; Dialog aktivieren 
SetFocus (hDialog)

EndScript 

; -----------------------------------------------------------------------------------------------
; Zeigt die Registerkarte "Codec" im Dialog 
; "Anpassungen und Effekte" an oder aktiviert diese
; -----------------------------------------------------------------------------------------------

Script ShowDialogMediaCodec ()
var
handle hDialog = FindWindow (0, "", cDialogNameMediaInfos)

; Dialog hat noch kein Handle (beim Programmstart)
If hDialog == 0 then
; also Strg+E an VLC senden um es anzuzeigen 
TypeCurrentScriptKey ()
; Befehle verarbeiten 
Pause ()
; Dialog-Handle neu bestimmen 
hDialog = FindWindow (0, "", cDialogNameMediaInfos)
; um dann das Fenster fokussieren 
SetFocus (hDialog)
Return
EndIf 

; Wenn der Dialog schon erzeugt ist, jedoch vom VLC ausgeblendet wurde 
If IsWindowVisible (hDialog) == False then
; Skript-Taste senden um ihn anzuzeigen 
TypeCurrentScriptKey ()
EndIf 

; Dialog aktivieren 
SetFocus (hDialog)

EndScript 

; -----------------------------------------------------------------------------------------------
; Zeigt den Dialog "VLM-Konfiguration" an oder aktiviert ihn
; -----------------------------------------------------------------------------------------------

Script ShowDialogVLMConfiguration ()
var
handle hDialog = FindWindow (0, "", cDialogNameVLMConfiguration)
; Dialog hat noch kein Handle (beim Programmstart)
If hDialog == 0 then
; also Strg+E an VLC senden um es anzuzeigen 
TypeCurrentScriptKey ()
; Befehle verarbeiten 
Pause ()
; Dialog-Handle neu bestimmen 
hDialog = FindWindow (0, "", cDialogNameVLMConfiguration)
; um dann das Fenster fokussieren 
SetFocus (hDialog)
Return
EndIf 

; Wenn der Dialog schon erzeugt ist, jedoch vom VLC ausgeblendet wurde 
If IsWindowVisible (hDialog) == False then
; Skript-Taste senden um ihn anzuzeigen 
TypeCurrentScriptKey ()
EndIf 

; Dialog aktivieren 
SetFocus (hDialog)

EndScript 

; -----------------------------------------------------------------------------------------------
; Zeigt den Dialog "Meldungen" an oder aktiviert ihn
; -----------------------------------------------------------------------------------------------

Script ShowDialogMessages ()
var
handle hDialog = FindWindow (0, "", cDialogNameMessages)
; Dialog hat noch kein Handle (beim Programmstart)
If hDialog == 0 then
; also Strg+E an VLC senden um es anzuzeigen 
TypeCurrentScriptKey ()
; Befehle verarbeiten 
Pause ()
; Dialog-Handle neu bestimmen 
hDialog = FindWindow (0, "", cDialogNameMessages)
; um dann das Fenster fokussieren 
SetFocus (hDialog)
Return
EndIf 

; Wenn der Dialog schon erzeugt ist, jedoch vom VLC ausgeblendet wurde 
If IsWindowVisible (hDialog) == False then
; Skript-Taste senden um ihn anzuzeigen 
TypeCurrentScriptKey ()
EndIf 

; Dialog aktivieren 
SetFocus (hDialog)
EndScript 

; -----------------------------------------------------------------------------------------------
; Zeigt den Dialog "Lesezeichen bearbeiten" an oder aktiviert ihn
; -----------------------------------------------------------------------------------------------

Script ShowDialogBookmarks ()
var
handle hDialog = FindWindow (0, "", cDialogNameBookmarks)
; Dialog hat noch kein Handle (beim Programmstart)
If hDialog == 0 then
; also Strg+B an VLC senden um es anzuzeigen 
TypeCurrentScriptKey ()
; Befehle verarbeiten 
Pause ()
; Dialog-Handle neu bestimmen 
hDialog = FindWindow (0, "", cDialogNameBookmarks)
; um dann das Fenster fokussieren 
SetFocus (hDialog)
Return
EndIf 

; Wenn der Dialog schon erzeugt ist, jedoch vom VLC ausgeblendet wurde 
If IsWindowVisible (hDialog) == False then
; Skript-Taste senden um ihn anzuzeigen 
TypeCurrentScriptKey ()
EndIf 

; Dialog aktivieren 
SetFocus (hDialog)
EndScript


; -----------------------------------------------------------------------------------------------
; Zeigt den Dialog "Lesezeichen bearbeiten" an oder aktiviert ihn
; -----------------------------------------------------------------------------------------------

Script ShowDialogGoTo ()
var
handle hDialog = FindWindow (0, "", cDialogNameGoTo)
; Dialog hat noch kein Handle (beim Programmstart)
If hDialog == 0 then
; also Strg+T an VLC senden um es anzuzeigen 
TypeCurrentScriptKey ()
; Befehle verarbeiten 
Pause ()
; Dialog-Handle neu bestimmen 
hDialog = FindWindow (0, "", cDialogNameGoTo)
; um dann das Fenster fokussieren 
SetFocus (hDialog)
Return
EndIf 

; Wenn der Dialog schon erzeugt ist, jedoch vom VLC ausgeblendet wurde 
If IsWindowVisible (hDialog) == False then
; Skript-Taste senden um ihn anzuzeigen 
TypeCurrentScriptKey ()
EndIf 

; Dialog aktivieren 
SetFocus (hDialog)
EndScript

; -----------------------------------------------------------------------------------------------
; Bringt das VLC-Player-Fenster in den Vordergund
; -----------------------------------------------------------------------------------------------

Script ShowPlayerWindow ()
var handle hAppWindow = FindWindow (0, "", cPlayerWindowName)
if !hAppWindow then 
hAppWindow = GetAppMainWindow (GetFocus())
EndIf 

Pause ()
SetFocus (hAppWindow)
EndScript 

; --------------------------------------------------------------------------------------------
; Hilfe (Anzeigen im virtuellen Betrachter)
; --------------------------------------------------------------------------------------------

Script SayHelp ()
; Sicherstellen, dass kein virtueller Betrachter geffnet ist 
EnsureNoUserBufferActive ()
UserBufferAddText ("Tastenkombinationen fr den VLC-Mediaplayer:")
UserBufferAddText (" ")
UserBufferAddText ("Anzeige von Infos im Player-Fenster:")
UserBufferAddText (" ")
UserBufferAddText ("Die folgenden Befehle werden eingeleitet mit der Tastenkombination: Strg+Leertaste: ")
UserBufferAddText (" ")
UserBufferAddText  ("V (Eselsbrcke Videoplayer): Aktiviert das Player-Fenster aus jedem beliebigem Dialog heraus")
UserBufferAddText ("H (Eselsbrcke Hilfe): Zeigt diesen Hilfetext in einem virtuellen Betrachter an")
UserBufferAddText ("P (Eselsbrcke Position): Ansage der aktuellen Position (abgelaufene Zeit, links des Schiebereglers)")
UserBufferAddText ("D (Eselsbrcke Dateiname): Ansage der aktuellen Datei (wenn Statusleiste eingeblendet ist)")
UserBufferAddText ("G (Eselsbrcke Geschwindigkeit): Ansage der Wiedergabegeschwindigkeit (wenn Statusleiste eingeblendet ist)")
UserBufferAddText ("A (Eselsbrcke Abspielliste): Schaltet zwischen Player-Ansicht und Playlist-Ansicht um")
UserBufferAddText ("F (Eselsbrcke Fenster): zeigt einen Auswahldialog mit geffneten VLC-Fenstern an")
UserBufferAddText ("W (Eselsbrcke Wiedergabeliste): zeigt einen Auswahldialog mit den zuletzt geffneten Dateien an")
UserBufferAddText ("T (Eselsbrcke Tabs): zeigt einen Auswahldialog mit denen im aktuellen Fenster verfgbaren Registerkarten an")
UserBufferAddText ("F1: Anzeigeeinstellung in der Positionsanzeige umschalten zwischen verbleibender Zeit und Gesamtlnge")
UserBufferAddText ("F2: Anzeigeeinstellung in der Statuszeile umschalten zwischen aktueller Position und verbleibender Zeit ")
UserBufferAddText ("F3: Wiedergabegeschwindigkeit ndern (langsamer)")
UserBufferAddText ("F4: Wiedergabegeschwindigkeit ndern (schneller)")
UserBufferAddText ("r (Eselsbrcke Restzeit): Ansage der Gesamtabspielzeit/noch verbleibenden Zeit, rechts des Schiebereglers")
UserBufferAddText ("l (Eselsbrcke Lnge): Ansage von Position und Gesamtlnge (wenn Statusleiste eingeblendet ist)")
UserBufferAddText (" ")
UserBufferAddText ("Bereits im VLC vergebene Tasten, bei denen JAWS zustzlich Infos spricht:")
UserBufferAddText (" ")
UserBufferAddText ("Strg+Pfeil oben: Ansage \"lauter\"")
UserBufferAddText ("Strg+Pfeil unten: Ansage \"leiser\"")
UserBufferAddText ("Anwendungsmentaste bzw. Umschalt+F10: Setzt Fokus auf Steuerelemente, sodass das Anwendungsmen ausgefhrt werden kann")
UserBufferAddText ("Umschalt+Pfeil links, Umschalt+Pfeil rechts, Alt+Pfeil links, Alt+Pfeil rechts, Strg+Pfeil links, Strg+Pfeil rechts: Taste an VLC weiterreichen und Position sprechen")
UserBufferAddText ("m: Stumm-Schaltung umschalten und Status sprechen")
UserBufferAddText ("r: Taste fr \"Zufall\" ausfhren und Status sprechen")
UserBufferAddText ("l: Taste fr \"Wiederholen\" ausfhren und Status sprechen")
UserBufferAddText ("Tab: Setzt im Player-Fenster den Fokus auf die nchste Schaltflche ")
UserBufferAddText ("Umschalt+Tab: Setzt im Player-Fenster den Fokus auf die vorherige Schaltflche ")
UserBufferAddText ("Enter: fhrt im Player-Fenster Schaltflchen aus ")
UserBufferAddText (" ")
UserBufferAddText ("VLC-Dialoge ausfhren oder aktivieren:")
UserBufferAddText (" ")
UserBufferAddText ("Strg+E: zeigt den Dialog \"Anpassungen und Effekte\" an oder aktiviert ihn")
UserBufferAddText ("Strg+I: zeigt den Dialog \"Medianinformationen\" an oder aktiviert ihn")
UserBufferAddText ("Strg+J: zeigt die Registerkarte \"Codec\" im Dialog \"Medianinformationen\" an oder aktiviert sie")
UserBufferAddText ("Strg+Umschalt+W: zeigt den VLM-Konfigurations-Dialog an oder aktiviert ihn")
UserBufferAddText ("Strg+M: zeigt den Dialog \"Meldungen\" an oder aktiviert ihn")
UserBufferAddText ("Strg+B: zeigt den Dialog \"Lesezeichen bearbeiten\" an oder aktiviert ihn")


; Virtueller Betrachter anzeigen 
UserBufferActivate ()
SayAll ()
EndScript

; --------------------------------------------------------------------------------------------
; Spricht den Skriptnamen
; --------------------------------------------------------------------------------------------

Script ScriptFileName ()
ScriptAndAppNames(MsgVLCFilename)
EndScript


